#ifndef _H_D8FA6DD95402CAED64FAF09BC57FD8A1_ConfigureOutputsKdFreqDeadbandCmd_DCPS_H_
#define _H_D8FA6DD95402CAED64FAF09BC57FD8A1_ConfigureOutputsKdFreqDeadbandCmd_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ConfigureOutputsKdFreqDeadbandCmd_.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface;

            typedef ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface * ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface> ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface> ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface_out;


            class ConfigureOutputsKdFreqDeadbandCmd_DataWriter;

            typedef ConfigureOutputsKdFreqDeadbandCmd_DataWriter * ConfigureOutputsKdFreqDeadbandCmd_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ConfigureOutputsKdFreqDeadbandCmd_DataWriter> ConfigureOutputsKdFreqDeadbandCmd_DataWriter_var;
            typedef DDS_DCPSInterface_out < ConfigureOutputsKdFreqDeadbandCmd_DataWriter> ConfigureOutputsKdFreqDeadbandCmd_DataWriter_out;


            class ConfigureOutputsKdFreqDeadbandCmd_DataReader;

            typedef ConfigureOutputsKdFreqDeadbandCmd_DataReader * ConfigureOutputsKdFreqDeadbandCmd_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ConfigureOutputsKdFreqDeadbandCmd_DataReader> ConfigureOutputsKdFreqDeadbandCmd_DataReader_var;
            typedef DDS_DCPSInterface_out < ConfigureOutputsKdFreqDeadbandCmd_DataReader> ConfigureOutputsKdFreqDeadbandCmd_DataReader_out;


            class ConfigureOutputsKdFreqDeadbandCmd_DataReaderView;

            typedef ConfigureOutputsKdFreqDeadbandCmd_DataReaderView * ConfigureOutputsKdFreqDeadbandCmd_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ConfigureOutputsKdFreqDeadbandCmd_DataReaderView> ConfigureOutputsKdFreqDeadbandCmd_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ConfigureOutputsKdFreqDeadbandCmd_DataReaderView> ConfigureOutputsKdFreqDeadbandCmd_DataReaderView_out;

            struct ConfigureOutputsKdFreqDeadbandCmd_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ConfigureOutputsKdFreqDeadbandCmd_, struct ConfigureOutputsKdFreqDeadbandCmd_Seq_uniq_> ConfigureOutputsKdFreqDeadbandCmd_Seq;
            typedef DDS_DCPSSequence_var < ConfigureOutputsKdFreqDeadbandCmd_Seq> ConfigureOutputsKdFreqDeadbandCmd_Seq_var;
            typedef DDS_DCPSSequence_out < ConfigureOutputsKdFreqDeadbandCmd_Seq> ConfigureOutputsKdFreqDeadbandCmd_Seq_out;

            class  ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface_ptr _ptr_type;
                typedef ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface_var _var_type;

                static ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface_ptr _duplicate (ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface () {};
                ~ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface () {};
            private:
                ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface (const ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface &);
                ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface & operator = (const ConfigureOutputsKdFreqDeadbandCmd_TypeSupportInterface &);
            };

            class  ConfigureOutputsKdFreqDeadbandCmd_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ConfigureOutputsKdFreqDeadbandCmd_DataWriter_ptr _ptr_type;
                typedef ConfigureOutputsKdFreqDeadbandCmd_DataWriter_var _var_type;

                static ConfigureOutputsKdFreqDeadbandCmd_DataWriter_ptr _duplicate (ConfigureOutputsKdFreqDeadbandCmd_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConfigureOutputsKdFreqDeadbandCmd_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ConfigureOutputsKdFreqDeadbandCmd_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConfigureOutputsKdFreqDeadbandCmd_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ConfigureOutputsKdFreqDeadbandCmd_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ConfigureOutputsKdFreqDeadbandCmd_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ConfigureOutputsKdFreqDeadbandCmd_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ConfigureOutputsKdFreqDeadbandCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ConfigureOutputsKdFreqDeadbandCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ConfigureOutputsKdFreqDeadbandCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ConfigureOutputsKdFreqDeadbandCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ConfigureOutputsKdFreqDeadbandCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ConfigureOutputsKdFreqDeadbandCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ConfigureOutputsKdFreqDeadbandCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ConfigureOutputsKdFreqDeadbandCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ConfigureOutputsKdFreqDeadbandCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ConfigureOutputsKdFreqDeadbandCmd_& instance_data) = 0;

            protected:
                ConfigureOutputsKdFreqDeadbandCmd_DataWriter () {};
                ~ConfigureOutputsKdFreqDeadbandCmd_DataWriter () {};
            private:
                ConfigureOutputsKdFreqDeadbandCmd_DataWriter (const ConfigureOutputsKdFreqDeadbandCmd_DataWriter &);
                ConfigureOutputsKdFreqDeadbandCmd_DataWriter & operator = (const ConfigureOutputsKdFreqDeadbandCmd_DataWriter &);
            };

            class  ConfigureOutputsKdFreqDeadbandCmd_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ConfigureOutputsKdFreqDeadbandCmd_DataReader_ptr _ptr_type;
                typedef ConfigureOutputsKdFreqDeadbandCmd_DataReader_var _var_type;

                static ConfigureOutputsKdFreqDeadbandCmd_DataReader_ptr _duplicate (ConfigureOutputsKdFreqDeadbandCmd_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConfigureOutputsKdFreqDeadbandCmd_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ConfigureOutputsKdFreqDeadbandCmd_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConfigureOutputsKdFreqDeadbandCmd_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ConfigureOutputsKdFreqDeadbandCmd_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ConfigureOutputsKdFreqDeadbandCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ConfigureOutputsKdFreqDeadbandCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ConfigureOutputsKdFreqDeadbandCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ConfigureOutputsKdFreqDeadbandCmd_& instance) = 0;

            protected:
                ConfigureOutputsKdFreqDeadbandCmd_DataReader () {};
                ~ConfigureOutputsKdFreqDeadbandCmd_DataReader () {};
            private:
                ConfigureOutputsKdFreqDeadbandCmd_DataReader (const ConfigureOutputsKdFreqDeadbandCmd_DataReader &);
                ConfigureOutputsKdFreqDeadbandCmd_DataReader & operator = (const ConfigureOutputsKdFreqDeadbandCmd_DataReader &);
            };

            class  ConfigureOutputsKdFreqDeadbandCmd_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ConfigureOutputsKdFreqDeadbandCmd_DataReaderView_ptr _ptr_type;
                typedef ConfigureOutputsKdFreqDeadbandCmd_DataReaderView_var _var_type;

                static ConfigureOutputsKdFreqDeadbandCmd_DataReaderView_ptr _duplicate (ConfigureOutputsKdFreqDeadbandCmd_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConfigureOutputsKdFreqDeadbandCmd_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ConfigureOutputsKdFreqDeadbandCmd_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConfigureOutputsKdFreqDeadbandCmd_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ConfigureOutputsKdFreqDeadbandCmd_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ConfigureOutputsKdFreqDeadbandCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ConfigureOutputsKdFreqDeadbandCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ConfigureOutputsKdFreqDeadbandCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ConfigureOutputsKdFreqDeadbandCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ConfigureOutputsKdFreqDeadbandCmd_& instance) = 0;

            protected:
                ConfigureOutputsKdFreqDeadbandCmd_DataReaderView () {};
                ~ConfigureOutputsKdFreqDeadbandCmd_DataReaderView () {};
            private:
                ConfigureOutputsKdFreqDeadbandCmd_DataReaderView (const ConfigureOutputsKdFreqDeadbandCmd_DataReaderView &);
                ConfigureOutputsKdFreqDeadbandCmd_DataReaderView & operator = (const ConfigureOutputsKdFreqDeadbandCmd_DataReaderView &);
            };
        }

    }

}

#endif
