#ifndef _H_DE55996EFB0E378DE513FAA02AA34272_ConfigureOutputsPwmFreqCmd_DCPS_H_
#define _H_DE55996EFB0E378DE513FAA02AA34272_ConfigureOutputsPwmFreqCmd_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ConfigureOutputsPwmFreqCmd_.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ConfigureOutputsPwmFreqCmd_TypeSupportInterface;

            typedef ConfigureOutputsPwmFreqCmd_TypeSupportInterface * ConfigureOutputsPwmFreqCmd_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ConfigureOutputsPwmFreqCmd_TypeSupportInterface> ConfigureOutputsPwmFreqCmd_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ConfigureOutputsPwmFreqCmd_TypeSupportInterface> ConfigureOutputsPwmFreqCmd_TypeSupportInterface_out;


            class ConfigureOutputsPwmFreqCmd_DataWriter;

            typedef ConfigureOutputsPwmFreqCmd_DataWriter * ConfigureOutputsPwmFreqCmd_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ConfigureOutputsPwmFreqCmd_DataWriter> ConfigureOutputsPwmFreqCmd_DataWriter_var;
            typedef DDS_DCPSInterface_out < ConfigureOutputsPwmFreqCmd_DataWriter> ConfigureOutputsPwmFreqCmd_DataWriter_out;


            class ConfigureOutputsPwmFreqCmd_DataReader;

            typedef ConfigureOutputsPwmFreqCmd_DataReader * ConfigureOutputsPwmFreqCmd_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ConfigureOutputsPwmFreqCmd_DataReader> ConfigureOutputsPwmFreqCmd_DataReader_var;
            typedef DDS_DCPSInterface_out < ConfigureOutputsPwmFreqCmd_DataReader> ConfigureOutputsPwmFreqCmd_DataReader_out;


            class ConfigureOutputsPwmFreqCmd_DataReaderView;

            typedef ConfigureOutputsPwmFreqCmd_DataReaderView * ConfigureOutputsPwmFreqCmd_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ConfigureOutputsPwmFreqCmd_DataReaderView> ConfigureOutputsPwmFreqCmd_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ConfigureOutputsPwmFreqCmd_DataReaderView> ConfigureOutputsPwmFreqCmd_DataReaderView_out;

            struct ConfigureOutputsPwmFreqCmd_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ConfigureOutputsPwmFreqCmd_, struct ConfigureOutputsPwmFreqCmd_Seq_uniq_> ConfigureOutputsPwmFreqCmd_Seq;
            typedef DDS_DCPSSequence_var < ConfigureOutputsPwmFreqCmd_Seq> ConfigureOutputsPwmFreqCmd_Seq_var;
            typedef DDS_DCPSSequence_out < ConfigureOutputsPwmFreqCmd_Seq> ConfigureOutputsPwmFreqCmd_Seq_out;

            class  ConfigureOutputsPwmFreqCmd_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ConfigureOutputsPwmFreqCmd_TypeSupportInterface_ptr _ptr_type;
                typedef ConfigureOutputsPwmFreqCmd_TypeSupportInterface_var _var_type;

                static ConfigureOutputsPwmFreqCmd_TypeSupportInterface_ptr _duplicate (ConfigureOutputsPwmFreqCmd_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConfigureOutputsPwmFreqCmd_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ConfigureOutputsPwmFreqCmd_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConfigureOutputsPwmFreqCmd_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ConfigureOutputsPwmFreqCmd_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ConfigureOutputsPwmFreqCmd_TypeSupportInterface () {};
                ~ConfigureOutputsPwmFreqCmd_TypeSupportInterface () {};
            private:
                ConfigureOutputsPwmFreqCmd_TypeSupportInterface (const ConfigureOutputsPwmFreqCmd_TypeSupportInterface &);
                ConfigureOutputsPwmFreqCmd_TypeSupportInterface & operator = (const ConfigureOutputsPwmFreqCmd_TypeSupportInterface &);
            };

            class  ConfigureOutputsPwmFreqCmd_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ConfigureOutputsPwmFreqCmd_DataWriter_ptr _ptr_type;
                typedef ConfigureOutputsPwmFreqCmd_DataWriter_var _var_type;

                static ConfigureOutputsPwmFreqCmd_DataWriter_ptr _duplicate (ConfigureOutputsPwmFreqCmd_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConfigureOutputsPwmFreqCmd_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ConfigureOutputsPwmFreqCmd_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConfigureOutputsPwmFreqCmd_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ConfigureOutputsPwmFreqCmd_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ConfigureOutputsPwmFreqCmd_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ConfigureOutputsPwmFreqCmd_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ConfigureOutputsPwmFreqCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ConfigureOutputsPwmFreqCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ConfigureOutputsPwmFreqCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ConfigureOutputsPwmFreqCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ConfigureOutputsPwmFreqCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ConfigureOutputsPwmFreqCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ConfigureOutputsPwmFreqCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ConfigureOutputsPwmFreqCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ConfigureOutputsPwmFreqCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ConfigureOutputsPwmFreqCmd_& instance_data) = 0;

            protected:
                ConfigureOutputsPwmFreqCmd_DataWriter () {};
                ~ConfigureOutputsPwmFreqCmd_DataWriter () {};
            private:
                ConfigureOutputsPwmFreqCmd_DataWriter (const ConfigureOutputsPwmFreqCmd_DataWriter &);
                ConfigureOutputsPwmFreqCmd_DataWriter & operator = (const ConfigureOutputsPwmFreqCmd_DataWriter &);
            };

            class  ConfigureOutputsPwmFreqCmd_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ConfigureOutputsPwmFreqCmd_DataReader_ptr _ptr_type;
                typedef ConfigureOutputsPwmFreqCmd_DataReader_var _var_type;

                static ConfigureOutputsPwmFreqCmd_DataReader_ptr _duplicate (ConfigureOutputsPwmFreqCmd_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConfigureOutputsPwmFreqCmd_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ConfigureOutputsPwmFreqCmd_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConfigureOutputsPwmFreqCmd_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ConfigureOutputsPwmFreqCmd_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ConfigureOutputsPwmFreqCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ConfigureOutputsPwmFreqCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ConfigureOutputsPwmFreqCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ConfigureOutputsPwmFreqCmd_& instance) = 0;

            protected:
                ConfigureOutputsPwmFreqCmd_DataReader () {};
                ~ConfigureOutputsPwmFreqCmd_DataReader () {};
            private:
                ConfigureOutputsPwmFreqCmd_DataReader (const ConfigureOutputsPwmFreqCmd_DataReader &);
                ConfigureOutputsPwmFreqCmd_DataReader & operator = (const ConfigureOutputsPwmFreqCmd_DataReader &);
            };

            class  ConfigureOutputsPwmFreqCmd_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ConfigureOutputsPwmFreqCmd_DataReaderView_ptr _ptr_type;
                typedef ConfigureOutputsPwmFreqCmd_DataReaderView_var _var_type;

                static ConfigureOutputsPwmFreqCmd_DataReaderView_ptr _duplicate (ConfigureOutputsPwmFreqCmd_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConfigureOutputsPwmFreqCmd_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ConfigureOutputsPwmFreqCmd_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConfigureOutputsPwmFreqCmd_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ConfigureOutputsPwmFreqCmd_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ConfigureOutputsPwmFreqCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ConfigureOutputsPwmFreqCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ConfigureOutputsPwmFreqCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ConfigureOutputsPwmFreqCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ConfigureOutputsPwmFreqCmd_& instance) = 0;

            protected:
                ConfigureOutputsPwmFreqCmd_DataReaderView () {};
                ~ConfigureOutputsPwmFreqCmd_DataReaderView () {};
            private:
                ConfigureOutputsPwmFreqCmd_DataReaderView (const ConfigureOutputsPwmFreqCmd_DataReaderView &);
                ConfigureOutputsPwmFreqCmd_DataReaderView & operator = (const ConfigureOutputsPwmFreqCmd_DataReaderView &);
            };
        }

    }

}

#endif
