#ifndef _H_EB0901758B2CDA310873745D6108A3DB_MotorCurrentRpt_DCPS_H_
#define _H_EB0901758B2CDA310873745D6108A3DB_MotorCurrentRpt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MotorCurrentRpt_.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MotorCurrentRpt_TypeSupportInterface;

            typedef MotorCurrentRpt_TypeSupportInterface * MotorCurrentRpt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MotorCurrentRpt_TypeSupportInterface> MotorCurrentRpt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MotorCurrentRpt_TypeSupportInterface> MotorCurrentRpt_TypeSupportInterface_out;


            class MotorCurrentRpt_DataWriter;

            typedef MotorCurrentRpt_DataWriter * MotorCurrentRpt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MotorCurrentRpt_DataWriter> MotorCurrentRpt_DataWriter_var;
            typedef DDS_DCPSInterface_out < MotorCurrentRpt_DataWriter> MotorCurrentRpt_DataWriter_out;


            class MotorCurrentRpt_DataReader;

            typedef MotorCurrentRpt_DataReader * MotorCurrentRpt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MotorCurrentRpt_DataReader> MotorCurrentRpt_DataReader_var;
            typedef DDS_DCPSInterface_out < MotorCurrentRpt_DataReader> MotorCurrentRpt_DataReader_out;


            class MotorCurrentRpt_DataReaderView;

            typedef MotorCurrentRpt_DataReaderView * MotorCurrentRpt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MotorCurrentRpt_DataReaderView> MotorCurrentRpt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MotorCurrentRpt_DataReaderView> MotorCurrentRpt_DataReaderView_out;

            struct MotorCurrentRpt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MotorCurrentRpt_, struct MotorCurrentRpt_Seq_uniq_> MotorCurrentRpt_Seq;
            typedef DDS_DCPSSequence_var < MotorCurrentRpt_Seq> MotorCurrentRpt_Seq_var;
            typedef DDS_DCPSSequence_out < MotorCurrentRpt_Seq> MotorCurrentRpt_Seq_out;

            class  MotorCurrentRpt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MotorCurrentRpt_TypeSupportInterface_ptr _ptr_type;
                typedef MotorCurrentRpt_TypeSupportInterface_var _var_type;

                static MotorCurrentRpt_TypeSupportInterface_ptr _duplicate (MotorCurrentRpt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorCurrentRpt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MotorCurrentRpt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorCurrentRpt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorCurrentRpt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MotorCurrentRpt_TypeSupportInterface () {};
                ~MotorCurrentRpt_TypeSupportInterface () {};
            private:
                MotorCurrentRpt_TypeSupportInterface (const MotorCurrentRpt_TypeSupportInterface &);
                MotorCurrentRpt_TypeSupportInterface & operator = (const MotorCurrentRpt_TypeSupportInterface &);
            };

            class  MotorCurrentRpt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MotorCurrentRpt_DataWriter_ptr _ptr_type;
                typedef MotorCurrentRpt_DataWriter_var _var_type;

                static MotorCurrentRpt_DataWriter_ptr _duplicate (MotorCurrentRpt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorCurrentRpt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MotorCurrentRpt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorCurrentRpt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorCurrentRpt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MotorCurrentRpt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MotorCurrentRpt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MotorCurrentRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MotorCurrentRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MotorCurrentRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MotorCurrentRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MotorCurrentRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MotorCurrentRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MotorCurrentRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MotorCurrentRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MotorCurrentRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MotorCurrentRpt_& instance_data) = 0;

            protected:
                MotorCurrentRpt_DataWriter () {};
                ~MotorCurrentRpt_DataWriter () {};
            private:
                MotorCurrentRpt_DataWriter (const MotorCurrentRpt_DataWriter &);
                MotorCurrentRpt_DataWriter & operator = (const MotorCurrentRpt_DataWriter &);
            };

            class  MotorCurrentRpt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MotorCurrentRpt_DataReader_ptr _ptr_type;
                typedef MotorCurrentRpt_DataReader_var _var_type;

                static MotorCurrentRpt_DataReader_ptr _duplicate (MotorCurrentRpt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorCurrentRpt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MotorCurrentRpt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorCurrentRpt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorCurrentRpt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MotorCurrentRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MotorCurrentRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MotorCurrentRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MotorCurrentRpt_& instance) = 0;

            protected:
                MotorCurrentRpt_DataReader () {};
                ~MotorCurrentRpt_DataReader () {};
            private:
                MotorCurrentRpt_DataReader (const MotorCurrentRpt_DataReader &);
                MotorCurrentRpt_DataReader & operator = (const MotorCurrentRpt_DataReader &);
            };

            class  MotorCurrentRpt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MotorCurrentRpt_DataReaderView_ptr _ptr_type;
                typedef MotorCurrentRpt_DataReaderView_var _var_type;

                static MotorCurrentRpt_DataReaderView_ptr _duplicate (MotorCurrentRpt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorCurrentRpt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MotorCurrentRpt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorCurrentRpt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorCurrentRpt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MotorCurrentRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MotorCurrentRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MotorCurrentRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MotorCurrentRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MotorCurrentRpt_& instance) = 0;

            protected:
                MotorCurrentRpt_DataReaderView () {};
                ~MotorCurrentRpt_DataReaderView () {};
            private:
                MotorCurrentRpt_DataReaderView (const MotorCurrentRpt_DataReaderView &);
                MotorCurrentRpt_DataReaderView & operator = (const MotorCurrentRpt_DataReaderView &);
            };
        }

    }

}

#endif
