#ifndef _H_28EA6FC01CFC3E86CFA295A2FD53F9A1_MotorOverCurrentConfigCmd_DCPS_H_
#define _H_28EA6FC01CFC3E86CFA295A2FD53F9A1_MotorOverCurrentConfigCmd_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MotorOverCurrentConfigCmd_.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MotorOverCurrentConfigCmd_TypeSupportInterface;

            typedef MotorOverCurrentConfigCmd_TypeSupportInterface * MotorOverCurrentConfigCmd_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MotorOverCurrentConfigCmd_TypeSupportInterface> MotorOverCurrentConfigCmd_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MotorOverCurrentConfigCmd_TypeSupportInterface> MotorOverCurrentConfigCmd_TypeSupportInterface_out;


            class MotorOverCurrentConfigCmd_DataWriter;

            typedef MotorOverCurrentConfigCmd_DataWriter * MotorOverCurrentConfigCmd_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MotorOverCurrentConfigCmd_DataWriter> MotorOverCurrentConfigCmd_DataWriter_var;
            typedef DDS_DCPSInterface_out < MotorOverCurrentConfigCmd_DataWriter> MotorOverCurrentConfigCmd_DataWriter_out;


            class MotorOverCurrentConfigCmd_DataReader;

            typedef MotorOverCurrentConfigCmd_DataReader * MotorOverCurrentConfigCmd_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MotorOverCurrentConfigCmd_DataReader> MotorOverCurrentConfigCmd_DataReader_var;
            typedef DDS_DCPSInterface_out < MotorOverCurrentConfigCmd_DataReader> MotorOverCurrentConfigCmd_DataReader_out;


            class MotorOverCurrentConfigCmd_DataReaderView;

            typedef MotorOverCurrentConfigCmd_DataReaderView * MotorOverCurrentConfigCmd_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MotorOverCurrentConfigCmd_DataReaderView> MotorOverCurrentConfigCmd_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MotorOverCurrentConfigCmd_DataReaderView> MotorOverCurrentConfigCmd_DataReaderView_out;

            struct MotorOverCurrentConfigCmd_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MotorOverCurrentConfigCmd_, struct MotorOverCurrentConfigCmd_Seq_uniq_> MotorOverCurrentConfigCmd_Seq;
            typedef DDS_DCPSSequence_var < MotorOverCurrentConfigCmd_Seq> MotorOverCurrentConfigCmd_Seq_var;
            typedef DDS_DCPSSequence_out < MotorOverCurrentConfigCmd_Seq> MotorOverCurrentConfigCmd_Seq_out;

            class  MotorOverCurrentConfigCmd_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MotorOverCurrentConfigCmd_TypeSupportInterface_ptr _ptr_type;
                typedef MotorOverCurrentConfigCmd_TypeSupportInterface_var _var_type;

                static MotorOverCurrentConfigCmd_TypeSupportInterface_ptr _duplicate (MotorOverCurrentConfigCmd_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorOverCurrentConfigCmd_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MotorOverCurrentConfigCmd_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorOverCurrentConfigCmd_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorOverCurrentConfigCmd_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MotorOverCurrentConfigCmd_TypeSupportInterface () {};
                ~MotorOverCurrentConfigCmd_TypeSupportInterface () {};
            private:
                MotorOverCurrentConfigCmd_TypeSupportInterface (const MotorOverCurrentConfigCmd_TypeSupportInterface &);
                MotorOverCurrentConfigCmd_TypeSupportInterface & operator = (const MotorOverCurrentConfigCmd_TypeSupportInterface &);
            };

            class  MotorOverCurrentConfigCmd_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MotorOverCurrentConfigCmd_DataWriter_ptr _ptr_type;
                typedef MotorOverCurrentConfigCmd_DataWriter_var _var_type;

                static MotorOverCurrentConfigCmd_DataWriter_ptr _duplicate (MotorOverCurrentConfigCmd_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorOverCurrentConfigCmd_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MotorOverCurrentConfigCmd_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorOverCurrentConfigCmd_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorOverCurrentConfigCmd_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MotorOverCurrentConfigCmd_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MotorOverCurrentConfigCmd_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MotorOverCurrentConfigCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MotorOverCurrentConfigCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MotorOverCurrentConfigCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MotorOverCurrentConfigCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MotorOverCurrentConfigCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MotorOverCurrentConfigCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MotorOverCurrentConfigCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MotorOverCurrentConfigCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MotorOverCurrentConfigCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MotorOverCurrentConfigCmd_& instance_data) = 0;

            protected:
                MotorOverCurrentConfigCmd_DataWriter () {};
                ~MotorOverCurrentConfigCmd_DataWriter () {};
            private:
                MotorOverCurrentConfigCmd_DataWriter (const MotorOverCurrentConfigCmd_DataWriter &);
                MotorOverCurrentConfigCmd_DataWriter & operator = (const MotorOverCurrentConfigCmd_DataWriter &);
            };

            class  MotorOverCurrentConfigCmd_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MotorOverCurrentConfigCmd_DataReader_ptr _ptr_type;
                typedef MotorOverCurrentConfigCmd_DataReader_var _var_type;

                static MotorOverCurrentConfigCmd_DataReader_ptr _duplicate (MotorOverCurrentConfigCmd_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorOverCurrentConfigCmd_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MotorOverCurrentConfigCmd_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorOverCurrentConfigCmd_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorOverCurrentConfigCmd_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MotorOverCurrentConfigCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MotorOverCurrentConfigCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MotorOverCurrentConfigCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MotorOverCurrentConfigCmd_& instance) = 0;

            protected:
                MotorOverCurrentConfigCmd_DataReader () {};
                ~MotorOverCurrentConfigCmd_DataReader () {};
            private:
                MotorOverCurrentConfigCmd_DataReader (const MotorOverCurrentConfigCmd_DataReader &);
                MotorOverCurrentConfigCmd_DataReader & operator = (const MotorOverCurrentConfigCmd_DataReader &);
            };

            class  MotorOverCurrentConfigCmd_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MotorOverCurrentConfigCmd_DataReaderView_ptr _ptr_type;
                typedef MotorOverCurrentConfigCmd_DataReaderView_var _var_type;

                static MotorOverCurrentConfigCmd_DataReaderView_ptr _duplicate (MotorOverCurrentConfigCmd_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MotorOverCurrentConfigCmd_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MotorOverCurrentConfigCmd_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MotorOverCurrentConfigCmd_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MotorOverCurrentConfigCmd_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MotorOverCurrentConfigCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MotorOverCurrentConfigCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MotorOverCurrentConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MotorOverCurrentConfigCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MotorOverCurrentConfigCmd_& instance) = 0;

            protected:
                MotorOverCurrentConfigCmd_DataReaderView () {};
                ~MotorOverCurrentConfigCmd_DataReaderView () {};
            private:
                MotorOverCurrentConfigCmd_DataReaderView (const MotorOverCurrentConfigCmd_DataReaderView &);
                MotorOverCurrentConfigCmd_DataReaderView & operator = (const MotorOverCurrentConfigCmd_DataReaderView &);
            };
        }

    }

}

#endif
