#ifndef _H_C7BD43BD5A4AFEC392BF4F224E0573AF_PositionCmd__H_
#define _H_C7BD43BD5A4AFEC392BF4F224E0573AF_PositionCmd__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  PositionCmd_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean confirm_;
                ::DDS::Boolean auto_reply_;
                ::DDS::Double position_;
                ::DDS::Boolean clutch_enable_;
                ::DDS::Boolean motor_enable_;
            };

            typedef DDS_DCPSStruct_var<PositionCmd_> PositionCmd__var;
            typedef DDS_DCPSStruct_out < PositionCmd_> PositionCmd__out;

        }

    }

}

#endif /* _H_C7BD43BD5A4AFEC392BF4F224E0573AF_PositionCmd__H_ */
