#ifndef _H_86A15A2789FBB9CD306C27351BC1E097_PositionReachErrorTimeConfigCmd_DCPS_H_
#define _H_86A15A2789FBB9CD306C27351BC1E097_PositionReachErrorTimeConfigCmd_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PositionReachErrorTimeConfigCmd_.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PositionReachErrorTimeConfigCmd_TypeSupportInterface;

            typedef PositionReachErrorTimeConfigCmd_TypeSupportInterface * PositionReachErrorTimeConfigCmd_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PositionReachErrorTimeConfigCmd_TypeSupportInterface> PositionReachErrorTimeConfigCmd_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PositionReachErrorTimeConfigCmd_TypeSupportInterface> PositionReachErrorTimeConfigCmd_TypeSupportInterface_out;


            class PositionReachErrorTimeConfigCmd_DataWriter;

            typedef PositionReachErrorTimeConfigCmd_DataWriter * PositionReachErrorTimeConfigCmd_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PositionReachErrorTimeConfigCmd_DataWriter> PositionReachErrorTimeConfigCmd_DataWriter_var;
            typedef DDS_DCPSInterface_out < PositionReachErrorTimeConfigCmd_DataWriter> PositionReachErrorTimeConfigCmd_DataWriter_out;


            class PositionReachErrorTimeConfigCmd_DataReader;

            typedef PositionReachErrorTimeConfigCmd_DataReader * PositionReachErrorTimeConfigCmd_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PositionReachErrorTimeConfigCmd_DataReader> PositionReachErrorTimeConfigCmd_DataReader_var;
            typedef DDS_DCPSInterface_out < PositionReachErrorTimeConfigCmd_DataReader> PositionReachErrorTimeConfigCmd_DataReader_out;


            class PositionReachErrorTimeConfigCmd_DataReaderView;

            typedef PositionReachErrorTimeConfigCmd_DataReaderView * PositionReachErrorTimeConfigCmd_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PositionReachErrorTimeConfigCmd_DataReaderView> PositionReachErrorTimeConfigCmd_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PositionReachErrorTimeConfigCmd_DataReaderView> PositionReachErrorTimeConfigCmd_DataReaderView_out;

            struct PositionReachErrorTimeConfigCmd_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PositionReachErrorTimeConfigCmd_, struct PositionReachErrorTimeConfigCmd_Seq_uniq_> PositionReachErrorTimeConfigCmd_Seq;
            typedef DDS_DCPSSequence_var < PositionReachErrorTimeConfigCmd_Seq> PositionReachErrorTimeConfigCmd_Seq_var;
            typedef DDS_DCPSSequence_out < PositionReachErrorTimeConfigCmd_Seq> PositionReachErrorTimeConfigCmd_Seq_out;

            class  PositionReachErrorTimeConfigCmd_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PositionReachErrorTimeConfigCmd_TypeSupportInterface_ptr _ptr_type;
                typedef PositionReachErrorTimeConfigCmd_TypeSupportInterface_var _var_type;

                static PositionReachErrorTimeConfigCmd_TypeSupportInterface_ptr _duplicate (PositionReachErrorTimeConfigCmd_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionReachErrorTimeConfigCmd_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PositionReachErrorTimeConfigCmd_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionReachErrorTimeConfigCmd_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionReachErrorTimeConfigCmd_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PositionReachErrorTimeConfigCmd_TypeSupportInterface () {};
                ~PositionReachErrorTimeConfigCmd_TypeSupportInterface () {};
            private:
                PositionReachErrorTimeConfigCmd_TypeSupportInterface (const PositionReachErrorTimeConfigCmd_TypeSupportInterface &);
                PositionReachErrorTimeConfigCmd_TypeSupportInterface & operator = (const PositionReachErrorTimeConfigCmd_TypeSupportInterface &);
            };

            class  PositionReachErrorTimeConfigCmd_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PositionReachErrorTimeConfigCmd_DataWriter_ptr _ptr_type;
                typedef PositionReachErrorTimeConfigCmd_DataWriter_var _var_type;

                static PositionReachErrorTimeConfigCmd_DataWriter_ptr _duplicate (PositionReachErrorTimeConfigCmd_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionReachErrorTimeConfigCmd_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PositionReachErrorTimeConfigCmd_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionReachErrorTimeConfigCmd_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionReachErrorTimeConfigCmd_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PositionReachErrorTimeConfigCmd_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PositionReachErrorTimeConfigCmd_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PositionReachErrorTimeConfigCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PositionReachErrorTimeConfigCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PositionReachErrorTimeConfigCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PositionReachErrorTimeConfigCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PositionReachErrorTimeConfigCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PositionReachErrorTimeConfigCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PositionReachErrorTimeConfigCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PositionReachErrorTimeConfigCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PositionReachErrorTimeConfigCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionReachErrorTimeConfigCmd_& instance_data) = 0;

            protected:
                PositionReachErrorTimeConfigCmd_DataWriter () {};
                ~PositionReachErrorTimeConfigCmd_DataWriter () {};
            private:
                PositionReachErrorTimeConfigCmd_DataWriter (const PositionReachErrorTimeConfigCmd_DataWriter &);
                PositionReachErrorTimeConfigCmd_DataWriter & operator = (const PositionReachErrorTimeConfigCmd_DataWriter &);
            };

            class  PositionReachErrorTimeConfigCmd_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PositionReachErrorTimeConfigCmd_DataReader_ptr _ptr_type;
                typedef PositionReachErrorTimeConfigCmd_DataReader_var _var_type;

                static PositionReachErrorTimeConfigCmd_DataReader_ptr _duplicate (PositionReachErrorTimeConfigCmd_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionReachErrorTimeConfigCmd_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PositionReachErrorTimeConfigCmd_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionReachErrorTimeConfigCmd_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionReachErrorTimeConfigCmd_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionReachErrorTimeConfigCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionReachErrorTimeConfigCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionReachErrorTimeConfigCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionReachErrorTimeConfigCmd_& instance) = 0;

            protected:
                PositionReachErrorTimeConfigCmd_DataReader () {};
                ~PositionReachErrorTimeConfigCmd_DataReader () {};
            private:
                PositionReachErrorTimeConfigCmd_DataReader (const PositionReachErrorTimeConfigCmd_DataReader &);
                PositionReachErrorTimeConfigCmd_DataReader & operator = (const PositionReachErrorTimeConfigCmd_DataReader &);
            };

            class  PositionReachErrorTimeConfigCmd_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PositionReachErrorTimeConfigCmd_DataReaderView_ptr _ptr_type;
                typedef PositionReachErrorTimeConfigCmd_DataReaderView_var _var_type;

                static PositionReachErrorTimeConfigCmd_DataReaderView_ptr _duplicate (PositionReachErrorTimeConfigCmd_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PositionReachErrorTimeConfigCmd_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PositionReachErrorTimeConfigCmd_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PositionReachErrorTimeConfigCmd_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PositionReachErrorTimeConfigCmd_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PositionReachErrorTimeConfigCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PositionReachErrorTimeConfigCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PositionReachErrorTimeConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PositionReachErrorTimeConfigCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PositionReachErrorTimeConfigCmd_& instance) = 0;

            protected:
                PositionReachErrorTimeConfigCmd_DataReaderView () {};
                ~PositionReachErrorTimeConfigCmd_DataReaderView () {};
            private:
                PositionReachErrorTimeConfigCmd_DataReaderView (const PositionReachErrorTimeConfigCmd_DataReaderView &);
                PositionReachErrorTimeConfigCmd_DataReaderView & operator = (const PositionReachErrorTimeConfigCmd_DataReaderView &);
            };
        }

    }

}

#endif
