#ifndef _H_7CBB4EF00455DD803E820BE77F8070D5_PriorityConfigCmd_DCPS_H_
#define _H_7CBB4EF00455DD803E820BE77F8070D5_PriorityConfigCmd_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PriorityConfigCmd_.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PriorityConfigCmd_TypeSupportInterface;

            typedef PriorityConfigCmd_TypeSupportInterface * PriorityConfigCmd_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PriorityConfigCmd_TypeSupportInterface> PriorityConfigCmd_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PriorityConfigCmd_TypeSupportInterface> PriorityConfigCmd_TypeSupportInterface_out;


            class PriorityConfigCmd_DataWriter;

            typedef PriorityConfigCmd_DataWriter * PriorityConfigCmd_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PriorityConfigCmd_DataWriter> PriorityConfigCmd_DataWriter_var;
            typedef DDS_DCPSInterface_out < PriorityConfigCmd_DataWriter> PriorityConfigCmd_DataWriter_out;


            class PriorityConfigCmd_DataReader;

            typedef PriorityConfigCmd_DataReader * PriorityConfigCmd_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PriorityConfigCmd_DataReader> PriorityConfigCmd_DataReader_var;
            typedef DDS_DCPSInterface_out < PriorityConfigCmd_DataReader> PriorityConfigCmd_DataReader_out;


            class PriorityConfigCmd_DataReaderView;

            typedef PriorityConfigCmd_DataReaderView * PriorityConfigCmd_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PriorityConfigCmd_DataReaderView> PriorityConfigCmd_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PriorityConfigCmd_DataReaderView> PriorityConfigCmd_DataReaderView_out;

            struct PriorityConfigCmd_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PriorityConfigCmd_, struct PriorityConfigCmd_Seq_uniq_> PriorityConfigCmd_Seq;
            typedef DDS_DCPSSequence_var < PriorityConfigCmd_Seq> PriorityConfigCmd_Seq_var;
            typedef DDS_DCPSSequence_out < PriorityConfigCmd_Seq> PriorityConfigCmd_Seq_out;

            class  PriorityConfigCmd_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PriorityConfigCmd_TypeSupportInterface_ptr _ptr_type;
                typedef PriorityConfigCmd_TypeSupportInterface_var _var_type;

                static PriorityConfigCmd_TypeSupportInterface_ptr _duplicate (PriorityConfigCmd_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PriorityConfigCmd_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PriorityConfigCmd_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PriorityConfigCmd_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PriorityConfigCmd_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PriorityConfigCmd_TypeSupportInterface () {};
                ~PriorityConfigCmd_TypeSupportInterface () {};
            private:
                PriorityConfigCmd_TypeSupportInterface (const PriorityConfigCmd_TypeSupportInterface &);
                PriorityConfigCmd_TypeSupportInterface & operator = (const PriorityConfigCmd_TypeSupportInterface &);
            };

            class  PriorityConfigCmd_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PriorityConfigCmd_DataWriter_ptr _ptr_type;
                typedef PriorityConfigCmd_DataWriter_var _var_type;

                static PriorityConfigCmd_DataWriter_ptr _duplicate (PriorityConfigCmd_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PriorityConfigCmd_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PriorityConfigCmd_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PriorityConfigCmd_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PriorityConfigCmd_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PriorityConfigCmd_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PriorityConfigCmd_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PriorityConfigCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PriorityConfigCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PriorityConfigCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PriorityConfigCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PriorityConfigCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PriorityConfigCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PriorityConfigCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PriorityConfigCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PriorityConfigCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PriorityConfigCmd_& instance_data) = 0;

            protected:
                PriorityConfigCmd_DataWriter () {};
                ~PriorityConfigCmd_DataWriter () {};
            private:
                PriorityConfigCmd_DataWriter (const PriorityConfigCmd_DataWriter &);
                PriorityConfigCmd_DataWriter & operator = (const PriorityConfigCmd_DataWriter &);
            };

            class  PriorityConfigCmd_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PriorityConfigCmd_DataReader_ptr _ptr_type;
                typedef PriorityConfigCmd_DataReader_var _var_type;

                static PriorityConfigCmd_DataReader_ptr _duplicate (PriorityConfigCmd_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PriorityConfigCmd_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PriorityConfigCmd_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PriorityConfigCmd_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PriorityConfigCmd_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PriorityConfigCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PriorityConfigCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PriorityConfigCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PriorityConfigCmd_& instance) = 0;

            protected:
                PriorityConfigCmd_DataReader () {};
                ~PriorityConfigCmd_DataReader () {};
            private:
                PriorityConfigCmd_DataReader (const PriorityConfigCmd_DataReader &);
                PriorityConfigCmd_DataReader & operator = (const PriorityConfigCmd_DataReader &);
            };

            class  PriorityConfigCmd_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PriorityConfigCmd_DataReaderView_ptr _ptr_type;
                typedef PriorityConfigCmd_DataReaderView_var _var_type;

                static PriorityConfigCmd_DataReaderView_ptr _duplicate (PriorityConfigCmd_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PriorityConfigCmd_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PriorityConfigCmd_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PriorityConfigCmd_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PriorityConfigCmd_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PriorityConfigCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PriorityConfigCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PriorityConfigCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PriorityConfigCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PriorityConfigCmd_& instance) = 0;

            protected:
                PriorityConfigCmd_DataReaderView () {};
                ~PriorityConfigCmd_DataReaderView () {};
            private:
                PriorityConfigCmd_DataReaderView (const PriorityConfigCmd_DataReaderView &);
                PriorityConfigCmd_DataReaderView & operator = (const PriorityConfigCmd_DataReaderView &);
            };
        }

    }

}

#endif
