#ifndef _H_5BB00B26E2E043D801F77A9D732D6493_ReassignReportIdCmd_DCPS_H_
#define _H_5BB00B26E2E043D801F77A9D732D6493_ReassignReportIdCmd_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ReassignReportIdCmd_.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ReassignReportIdCmd_TypeSupportInterface;

            typedef ReassignReportIdCmd_TypeSupportInterface * ReassignReportIdCmd_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ReassignReportIdCmd_TypeSupportInterface> ReassignReportIdCmd_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ReassignReportIdCmd_TypeSupportInterface> ReassignReportIdCmd_TypeSupportInterface_out;


            class ReassignReportIdCmd_DataWriter;

            typedef ReassignReportIdCmd_DataWriter * ReassignReportIdCmd_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ReassignReportIdCmd_DataWriter> ReassignReportIdCmd_DataWriter_var;
            typedef DDS_DCPSInterface_out < ReassignReportIdCmd_DataWriter> ReassignReportIdCmd_DataWriter_out;


            class ReassignReportIdCmd_DataReader;

            typedef ReassignReportIdCmd_DataReader * ReassignReportIdCmd_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ReassignReportIdCmd_DataReader> ReassignReportIdCmd_DataReader_var;
            typedef DDS_DCPSInterface_out < ReassignReportIdCmd_DataReader> ReassignReportIdCmd_DataReader_out;


            class ReassignReportIdCmd_DataReaderView;

            typedef ReassignReportIdCmd_DataReaderView * ReassignReportIdCmd_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ReassignReportIdCmd_DataReaderView> ReassignReportIdCmd_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ReassignReportIdCmd_DataReaderView> ReassignReportIdCmd_DataReaderView_out;

            struct ReassignReportIdCmd_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ReassignReportIdCmd_, struct ReassignReportIdCmd_Seq_uniq_> ReassignReportIdCmd_Seq;
            typedef DDS_DCPSSequence_var < ReassignReportIdCmd_Seq> ReassignReportIdCmd_Seq_var;
            typedef DDS_DCPSSequence_out < ReassignReportIdCmd_Seq> ReassignReportIdCmd_Seq_out;

            class  ReassignReportIdCmd_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ReassignReportIdCmd_TypeSupportInterface_ptr _ptr_type;
                typedef ReassignReportIdCmd_TypeSupportInterface_var _var_type;

                static ReassignReportIdCmd_TypeSupportInterface_ptr _duplicate (ReassignReportIdCmd_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReassignReportIdCmd_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ReassignReportIdCmd_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReassignReportIdCmd_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ReassignReportIdCmd_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ReassignReportIdCmd_TypeSupportInterface () {};
                ~ReassignReportIdCmd_TypeSupportInterface () {};
            private:
                ReassignReportIdCmd_TypeSupportInterface (const ReassignReportIdCmd_TypeSupportInterface &);
                ReassignReportIdCmd_TypeSupportInterface & operator = (const ReassignReportIdCmd_TypeSupportInterface &);
            };

            class  ReassignReportIdCmd_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ReassignReportIdCmd_DataWriter_ptr _ptr_type;
                typedef ReassignReportIdCmd_DataWriter_var _var_type;

                static ReassignReportIdCmd_DataWriter_ptr _duplicate (ReassignReportIdCmd_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReassignReportIdCmd_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ReassignReportIdCmd_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReassignReportIdCmd_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ReassignReportIdCmd_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ReassignReportIdCmd_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ReassignReportIdCmd_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ReassignReportIdCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ReassignReportIdCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ReassignReportIdCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ReassignReportIdCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ReassignReportIdCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ReassignReportIdCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ReassignReportIdCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ReassignReportIdCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ReassignReportIdCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReassignReportIdCmd_& instance_data) = 0;

            protected:
                ReassignReportIdCmd_DataWriter () {};
                ~ReassignReportIdCmd_DataWriter () {};
            private:
                ReassignReportIdCmd_DataWriter (const ReassignReportIdCmd_DataWriter &);
                ReassignReportIdCmd_DataWriter & operator = (const ReassignReportIdCmd_DataWriter &);
            };

            class  ReassignReportIdCmd_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ReassignReportIdCmd_DataReader_ptr _ptr_type;
                typedef ReassignReportIdCmd_DataReader_var _var_type;

                static ReassignReportIdCmd_DataReader_ptr _duplicate (ReassignReportIdCmd_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReassignReportIdCmd_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ReassignReportIdCmd_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReassignReportIdCmd_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ReassignReportIdCmd_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ReassignReportIdCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ReassignReportIdCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ReassignReportIdCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReassignReportIdCmd_& instance) = 0;

            protected:
                ReassignReportIdCmd_DataReader () {};
                ~ReassignReportIdCmd_DataReader () {};
            private:
                ReassignReportIdCmd_DataReader (const ReassignReportIdCmd_DataReader &);
                ReassignReportIdCmd_DataReader & operator = (const ReassignReportIdCmd_DataReader &);
            };

            class  ReassignReportIdCmd_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ReassignReportIdCmd_DataReaderView_ptr _ptr_type;
                typedef ReassignReportIdCmd_DataReaderView_var _var_type;

                static ReassignReportIdCmd_DataReaderView_ptr _duplicate (ReassignReportIdCmd_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ReassignReportIdCmd_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ReassignReportIdCmd_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ReassignReportIdCmd_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ReassignReportIdCmd_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ReassignReportIdCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ReassignReportIdCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ReassignReportIdCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ReassignReportIdCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ReassignReportIdCmd_& instance) = 0;

            protected:
                ReassignReportIdCmd_DataReaderView () {};
                ~ReassignReportIdCmd_DataReaderView () {};
            private:
                ReassignReportIdCmd_DataReaderView (const ReassignReportIdCmd_DataReaderView &);
                ReassignReportIdCmd_DataReaderView & operator = (const ReassignReportIdCmd_DataReaderView &);
            };
        }

    }

}

#endif
