#ifndef _H_F9B92DF4D7E3596E3A128878BFC8098B_ReportIndex__H_
#define _H_F9B92DF4D7E3596E3A128878BFC8098B_ReportIndex__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ReportIndex_Constants
            {
                const ::DDS::Octet POSITION_REPORT_INDEX_ = 128;

                const ::DDS::Octet MOTOR_CURRENT_REPORT_INDEX_ = 129;

                const ::DDS::Octet ENHANCED_POSITION_REPORT_INDEX_ = 152;

                const ::DDS::Octet UNIQUE_DEVICE_ID_REPORTS_INDEX_ = 167;

                const ::DDS::Octet SOFTWARE_REVISION_REPORT_INDEX_ = 229;

                const ::DDS::Octet ZEROING_MESSAGE_REPORT_INDEX_ = 238;

            }

            struct  ReportIndex_
            {
                ::DDS::Octet report_index_;
            };

            typedef DDS_DCPSStruct_var<ReportIndex_> ReportIndex__var;
            typedef ReportIndex_& ReportIndex__out;

        }

    }

}

#endif /* _H_F9B92DF4D7E3596E3A128878BFC8098B_ReportIndex__H_ */
