#ifndef _H_85C4D25747188A938CF095ACE17C01A0_ResetCmd__H_
#define _H_85C4D25747188A938CF095ACE17C01A0_ResetCmd__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace ResetCmd_Constants
            {
                const ::DDS::Octet RESET_OUTPUTS_ = 0;

                const ::DDS::Octet RESET_USER_DEFINED_IDS_ = 1;

                const ::DDS::Octet RESET_REPORT_RATES_ = 2;

                const ::DDS::Octet RESET_HARDWARE_CONFIGURATIONS_ = 3;

                const ::DDS::Octet RESET_USER_CONFIGURATIONS_ = 4;

                const ::DDS::Octet RESET_EVERYTHING_ = 5;

                const ::DDS::Octet RESET_NONE_ = 6;

            }

            struct  ResetCmd_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean confirm_;
                ::DDS::Octet reset_type_;
                ::DDS::Boolean reset_user_rpt_id_;
                ::DDS::Boolean reset_user_cmd_id_1_;
                ::DDS::Boolean reset_user_cmd_id_2_;
                ::DDS::Boolean reset_user_cmd_id_3_;
                ::DDS::Boolean reset_user_cmd_id_4_;
                ::DDS::Boolean disable_user_rpt_id_;
                ::DDS::Boolean reenable_default_cmd_id_;
            };

            typedef DDS_DCPSStruct_var<ResetCmd_> ResetCmd__var;
            typedef DDS_DCPSStruct_out < ResetCmd_> ResetCmd__out;

        }

    }

}

#endif /* _H_85C4D25747188A938CF095ACE17C01A0_ResetCmd__H_ */
