#ifndef _H_77914BF2FD86F5A570729D0FD0FA07AF_ScheduledReportRatesReq_DCPS_H_
#define _H_77914BF2FD86F5A570729D0FD0FA07AF_ScheduledReportRatesReq_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ScheduledReportRatesReq_.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ScheduledReportRatesReq_TypeSupportInterface;

            typedef ScheduledReportRatesReq_TypeSupportInterface * ScheduledReportRatesReq_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ScheduledReportRatesReq_TypeSupportInterface> ScheduledReportRatesReq_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ScheduledReportRatesReq_TypeSupportInterface> ScheduledReportRatesReq_TypeSupportInterface_out;


            class ScheduledReportRatesReq_DataWriter;

            typedef ScheduledReportRatesReq_DataWriter * ScheduledReportRatesReq_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ScheduledReportRatesReq_DataWriter> ScheduledReportRatesReq_DataWriter_var;
            typedef DDS_DCPSInterface_out < ScheduledReportRatesReq_DataWriter> ScheduledReportRatesReq_DataWriter_out;


            class ScheduledReportRatesReq_DataReader;

            typedef ScheduledReportRatesReq_DataReader * ScheduledReportRatesReq_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ScheduledReportRatesReq_DataReader> ScheduledReportRatesReq_DataReader_var;
            typedef DDS_DCPSInterface_out < ScheduledReportRatesReq_DataReader> ScheduledReportRatesReq_DataReader_out;


            class ScheduledReportRatesReq_DataReaderView;

            typedef ScheduledReportRatesReq_DataReaderView * ScheduledReportRatesReq_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ScheduledReportRatesReq_DataReaderView> ScheduledReportRatesReq_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ScheduledReportRatesReq_DataReaderView> ScheduledReportRatesReq_DataReaderView_out;

            struct ScheduledReportRatesReq_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ScheduledReportRatesReq_, struct ScheduledReportRatesReq_Seq_uniq_> ScheduledReportRatesReq_Seq;
            typedef DDS_DCPSSequence_var < ScheduledReportRatesReq_Seq> ScheduledReportRatesReq_Seq_var;
            typedef DDS_DCPSSequence_out < ScheduledReportRatesReq_Seq> ScheduledReportRatesReq_Seq_out;

            class  ScheduledReportRatesReq_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ScheduledReportRatesReq_TypeSupportInterface_ptr _ptr_type;
                typedef ScheduledReportRatesReq_TypeSupportInterface_var _var_type;

                static ScheduledReportRatesReq_TypeSupportInterface_ptr _duplicate (ScheduledReportRatesReq_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScheduledReportRatesReq_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ScheduledReportRatesReq_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScheduledReportRatesReq_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ScheduledReportRatesReq_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ScheduledReportRatesReq_TypeSupportInterface () {};
                ~ScheduledReportRatesReq_TypeSupportInterface () {};
            private:
                ScheduledReportRatesReq_TypeSupportInterface (const ScheduledReportRatesReq_TypeSupportInterface &);
                ScheduledReportRatesReq_TypeSupportInterface & operator = (const ScheduledReportRatesReq_TypeSupportInterface &);
            };

            class  ScheduledReportRatesReq_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ScheduledReportRatesReq_DataWriter_ptr _ptr_type;
                typedef ScheduledReportRatesReq_DataWriter_var _var_type;

                static ScheduledReportRatesReq_DataWriter_ptr _duplicate (ScheduledReportRatesReq_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScheduledReportRatesReq_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ScheduledReportRatesReq_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScheduledReportRatesReq_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ScheduledReportRatesReq_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ScheduledReportRatesReq_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ScheduledReportRatesReq_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ScheduledReportRatesReq_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ScheduledReportRatesReq_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ScheduledReportRatesReq_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ScheduledReportRatesReq_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ScheduledReportRatesReq_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ScheduledReportRatesReq_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ScheduledReportRatesReq_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ScheduledReportRatesReq_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ScheduledReportRatesReq_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScheduledReportRatesReq_& instance_data) = 0;

            protected:
                ScheduledReportRatesReq_DataWriter () {};
                ~ScheduledReportRatesReq_DataWriter () {};
            private:
                ScheduledReportRatesReq_DataWriter (const ScheduledReportRatesReq_DataWriter &);
                ScheduledReportRatesReq_DataWriter & operator = (const ScheduledReportRatesReq_DataWriter &);
            };

            class  ScheduledReportRatesReq_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ScheduledReportRatesReq_DataReader_ptr _ptr_type;
                typedef ScheduledReportRatesReq_DataReader_var _var_type;

                static ScheduledReportRatesReq_DataReader_ptr _duplicate (ScheduledReportRatesReq_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScheduledReportRatesReq_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ScheduledReportRatesReq_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScheduledReportRatesReq_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ScheduledReportRatesReq_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScheduledReportRatesReq_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScheduledReportRatesReq_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScheduledReportRatesReq_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScheduledReportRatesReq_& instance) = 0;

            protected:
                ScheduledReportRatesReq_DataReader () {};
                ~ScheduledReportRatesReq_DataReader () {};
            private:
                ScheduledReportRatesReq_DataReader (const ScheduledReportRatesReq_DataReader &);
                ScheduledReportRatesReq_DataReader & operator = (const ScheduledReportRatesReq_DataReader &);
            };

            class  ScheduledReportRatesReq_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ScheduledReportRatesReq_DataReaderView_ptr _ptr_type;
                typedef ScheduledReportRatesReq_DataReaderView_var _var_type;

                static ScheduledReportRatesReq_DataReaderView_ptr _duplicate (ScheduledReportRatesReq_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ScheduledReportRatesReq_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ScheduledReportRatesReq_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ScheduledReportRatesReq_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ScheduledReportRatesReq_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ScheduledReportRatesReq_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ScheduledReportRatesReq_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ScheduledReportRatesReq_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ScheduledReportRatesReq_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ScheduledReportRatesReq_& instance) = 0;

            protected:
                ScheduledReportRatesReq_DataReaderView () {};
                ~ScheduledReportRatesReq_DataReaderView () {};
            private:
                ScheduledReportRatesReq_DataReaderView (const ScheduledReportRatesReq_DataReaderView &);
                ScheduledReportRatesReq_DataReaderView & operator = (const ScheduledReportRatesReq_DataReaderView &);
            };
        }

    }

}

#endif
