#ifndef _H_F8D2BF33CF2E5EEE34F2D82B33D17DE9_SoftwareVersionReq_DCPS_H_
#define _H_F8D2BF33CF2E5EEE34F2D82B33D17DE9_SoftwareVersionReq_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SoftwareVersionReq_.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SoftwareVersionReq_TypeSupportInterface;

            typedef SoftwareVersionReq_TypeSupportInterface * SoftwareVersionReq_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SoftwareVersionReq_TypeSupportInterface> SoftwareVersionReq_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SoftwareVersionReq_TypeSupportInterface> SoftwareVersionReq_TypeSupportInterface_out;


            class SoftwareVersionReq_DataWriter;

            typedef SoftwareVersionReq_DataWriter * SoftwareVersionReq_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SoftwareVersionReq_DataWriter> SoftwareVersionReq_DataWriter_var;
            typedef DDS_DCPSInterface_out < SoftwareVersionReq_DataWriter> SoftwareVersionReq_DataWriter_out;


            class SoftwareVersionReq_DataReader;

            typedef SoftwareVersionReq_DataReader * SoftwareVersionReq_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SoftwareVersionReq_DataReader> SoftwareVersionReq_DataReader_var;
            typedef DDS_DCPSInterface_out < SoftwareVersionReq_DataReader> SoftwareVersionReq_DataReader_out;


            class SoftwareVersionReq_DataReaderView;

            typedef SoftwareVersionReq_DataReaderView * SoftwareVersionReq_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SoftwareVersionReq_DataReaderView> SoftwareVersionReq_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SoftwareVersionReq_DataReaderView> SoftwareVersionReq_DataReaderView_out;

            struct SoftwareVersionReq_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SoftwareVersionReq_, struct SoftwareVersionReq_Seq_uniq_> SoftwareVersionReq_Seq;
            typedef DDS_DCPSSequence_var < SoftwareVersionReq_Seq> SoftwareVersionReq_Seq_var;
            typedef DDS_DCPSSequence_out < SoftwareVersionReq_Seq> SoftwareVersionReq_Seq_out;

            class  SoftwareVersionReq_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SoftwareVersionReq_TypeSupportInterface_ptr _ptr_type;
                typedef SoftwareVersionReq_TypeSupportInterface_var _var_type;

                static SoftwareVersionReq_TypeSupportInterface_ptr _duplicate (SoftwareVersionReq_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SoftwareVersionReq_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SoftwareVersionReq_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SoftwareVersionReq_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SoftwareVersionReq_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SoftwareVersionReq_TypeSupportInterface () {};
                ~SoftwareVersionReq_TypeSupportInterface () {};
            private:
                SoftwareVersionReq_TypeSupportInterface (const SoftwareVersionReq_TypeSupportInterface &);
                SoftwareVersionReq_TypeSupportInterface & operator = (const SoftwareVersionReq_TypeSupportInterface &);
            };

            class  SoftwareVersionReq_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SoftwareVersionReq_DataWriter_ptr _ptr_type;
                typedef SoftwareVersionReq_DataWriter_var _var_type;

                static SoftwareVersionReq_DataWriter_ptr _duplicate (SoftwareVersionReq_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SoftwareVersionReq_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SoftwareVersionReq_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SoftwareVersionReq_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SoftwareVersionReq_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SoftwareVersionReq_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SoftwareVersionReq_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SoftwareVersionReq_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SoftwareVersionReq_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SoftwareVersionReq_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SoftwareVersionReq_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SoftwareVersionReq_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SoftwareVersionReq_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SoftwareVersionReq_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SoftwareVersionReq_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SoftwareVersionReq_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SoftwareVersionReq_& instance_data) = 0;

            protected:
                SoftwareVersionReq_DataWriter () {};
                ~SoftwareVersionReq_DataWriter () {};
            private:
                SoftwareVersionReq_DataWriter (const SoftwareVersionReq_DataWriter &);
                SoftwareVersionReq_DataWriter & operator = (const SoftwareVersionReq_DataWriter &);
            };

            class  SoftwareVersionReq_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SoftwareVersionReq_DataReader_ptr _ptr_type;
                typedef SoftwareVersionReq_DataReader_var _var_type;

                static SoftwareVersionReq_DataReader_ptr _duplicate (SoftwareVersionReq_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SoftwareVersionReq_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SoftwareVersionReq_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SoftwareVersionReq_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SoftwareVersionReq_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SoftwareVersionReq_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SoftwareVersionReq_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SoftwareVersionReq_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SoftwareVersionReq_& instance) = 0;

            protected:
                SoftwareVersionReq_DataReader () {};
                ~SoftwareVersionReq_DataReader () {};
            private:
                SoftwareVersionReq_DataReader (const SoftwareVersionReq_DataReader &);
                SoftwareVersionReq_DataReader & operator = (const SoftwareVersionReq_DataReader &);
            };

            class  SoftwareVersionReq_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SoftwareVersionReq_DataReaderView_ptr _ptr_type;
                typedef SoftwareVersionReq_DataReaderView_var _var_type;

                static SoftwareVersionReq_DataReaderView_ptr _duplicate (SoftwareVersionReq_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SoftwareVersionReq_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SoftwareVersionReq_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SoftwareVersionReq_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SoftwareVersionReq_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SoftwareVersionReq_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SoftwareVersionReq_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SoftwareVersionReq_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SoftwareVersionReq_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SoftwareVersionReq_& instance) = 0;

            protected:
                SoftwareVersionReq_DataReaderView () {};
                ~SoftwareVersionReq_DataReaderView () {};
            private:
                SoftwareVersionReq_DataReaderView (const SoftwareVersionReq_DataReaderView &);
                SoftwareVersionReq_DataReaderView & operator = (const SoftwareVersionReq_DataReaderView &);
            };
        }

    }

}

#endif
