#ifndef _H_2F525F35CB1880940B425EADBB47B4E3_UniqueDeviceIdRpt_DCPS_H_
#define _H_2F525F35CB1880940B425EADBB47B4E3_UniqueDeviceIdRpt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "UniqueDeviceIdRpt_.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class UniqueDeviceIdRpt_TypeSupportInterface;

            typedef UniqueDeviceIdRpt_TypeSupportInterface * UniqueDeviceIdRpt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UniqueDeviceIdRpt_TypeSupportInterface> UniqueDeviceIdRpt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UniqueDeviceIdRpt_TypeSupportInterface> UniqueDeviceIdRpt_TypeSupportInterface_out;


            class UniqueDeviceIdRpt_DataWriter;

            typedef UniqueDeviceIdRpt_DataWriter * UniqueDeviceIdRpt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UniqueDeviceIdRpt_DataWriter> UniqueDeviceIdRpt_DataWriter_var;
            typedef DDS_DCPSInterface_out < UniqueDeviceIdRpt_DataWriter> UniqueDeviceIdRpt_DataWriter_out;


            class UniqueDeviceIdRpt_DataReader;

            typedef UniqueDeviceIdRpt_DataReader * UniqueDeviceIdRpt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UniqueDeviceIdRpt_DataReader> UniqueDeviceIdRpt_DataReader_var;
            typedef DDS_DCPSInterface_out < UniqueDeviceIdRpt_DataReader> UniqueDeviceIdRpt_DataReader_out;


            class UniqueDeviceIdRpt_DataReaderView;

            typedef UniqueDeviceIdRpt_DataReaderView * UniqueDeviceIdRpt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UniqueDeviceIdRpt_DataReaderView> UniqueDeviceIdRpt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UniqueDeviceIdRpt_DataReaderView> UniqueDeviceIdRpt_DataReaderView_out;

            struct UniqueDeviceIdRpt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < UniqueDeviceIdRpt_, struct UniqueDeviceIdRpt_Seq_uniq_> UniqueDeviceIdRpt_Seq;
            typedef DDS_DCPSSequence_var < UniqueDeviceIdRpt_Seq> UniqueDeviceIdRpt_Seq_var;
            typedef DDS_DCPSSequence_out < UniqueDeviceIdRpt_Seq> UniqueDeviceIdRpt_Seq_out;

            class  UniqueDeviceIdRpt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UniqueDeviceIdRpt_TypeSupportInterface_ptr _ptr_type;
                typedef UniqueDeviceIdRpt_TypeSupportInterface_var _var_type;

                static UniqueDeviceIdRpt_TypeSupportInterface_ptr _duplicate (UniqueDeviceIdRpt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UniqueDeviceIdRpt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UniqueDeviceIdRpt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UniqueDeviceIdRpt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UniqueDeviceIdRpt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UniqueDeviceIdRpt_TypeSupportInterface () {};
                ~UniqueDeviceIdRpt_TypeSupportInterface () {};
            private:
                UniqueDeviceIdRpt_TypeSupportInterface (const UniqueDeviceIdRpt_TypeSupportInterface &);
                UniqueDeviceIdRpt_TypeSupportInterface & operator = (const UniqueDeviceIdRpt_TypeSupportInterface &);
            };

            class  UniqueDeviceIdRpt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UniqueDeviceIdRpt_DataWriter_ptr _ptr_type;
                typedef UniqueDeviceIdRpt_DataWriter_var _var_type;

                static UniqueDeviceIdRpt_DataWriter_ptr _duplicate (UniqueDeviceIdRpt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UniqueDeviceIdRpt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UniqueDeviceIdRpt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UniqueDeviceIdRpt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UniqueDeviceIdRpt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UniqueDeviceIdRpt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UniqueDeviceIdRpt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UniqueDeviceIdRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UniqueDeviceIdRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UniqueDeviceIdRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UniqueDeviceIdRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UniqueDeviceIdRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UniqueDeviceIdRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UniqueDeviceIdRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UniqueDeviceIdRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UniqueDeviceIdRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UniqueDeviceIdRpt_& instance_data) = 0;

            protected:
                UniqueDeviceIdRpt_DataWriter () {};
                ~UniqueDeviceIdRpt_DataWriter () {};
            private:
                UniqueDeviceIdRpt_DataWriter (const UniqueDeviceIdRpt_DataWriter &);
                UniqueDeviceIdRpt_DataWriter & operator = (const UniqueDeviceIdRpt_DataWriter &);
            };

            class  UniqueDeviceIdRpt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UniqueDeviceIdRpt_DataReader_ptr _ptr_type;
                typedef UniqueDeviceIdRpt_DataReader_var _var_type;

                static UniqueDeviceIdRpt_DataReader_ptr _duplicate (UniqueDeviceIdRpt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UniqueDeviceIdRpt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UniqueDeviceIdRpt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UniqueDeviceIdRpt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UniqueDeviceIdRpt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UniqueDeviceIdRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UniqueDeviceIdRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UniqueDeviceIdRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UniqueDeviceIdRpt_& instance) = 0;

            protected:
                UniqueDeviceIdRpt_DataReader () {};
                ~UniqueDeviceIdRpt_DataReader () {};
            private:
                UniqueDeviceIdRpt_DataReader (const UniqueDeviceIdRpt_DataReader &);
                UniqueDeviceIdRpt_DataReader & operator = (const UniqueDeviceIdRpt_DataReader &);
            };

            class  UniqueDeviceIdRpt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UniqueDeviceIdRpt_DataReaderView_ptr _ptr_type;
                typedef UniqueDeviceIdRpt_DataReaderView_var _var_type;

                static UniqueDeviceIdRpt_DataReaderView_ptr _duplicate (UniqueDeviceIdRpt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UniqueDeviceIdRpt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UniqueDeviceIdRpt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UniqueDeviceIdRpt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UniqueDeviceIdRpt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UniqueDeviceIdRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UniqueDeviceIdRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UniqueDeviceIdRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UniqueDeviceIdRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UniqueDeviceIdRpt_& instance) = 0;

            protected:
                UniqueDeviceIdRpt_DataReaderView () {};
                ~UniqueDeviceIdRpt_DataReaderView () {};
            private:
                UniqueDeviceIdRpt_DataReaderView (const UniqueDeviceIdRpt_DataReaderView &);
                UniqueDeviceIdRpt_DataReaderView & operator = (const UniqueDeviceIdRpt_DataReaderView &);
            };
        }

    }

}

#endif
