#ifndef _H_C004F1FA38750649C64B287157DE36E1_ZeroingMessageRpt_DCPS_H_
#define _H_C004F1FA38750649C64B287157DE36E1_ZeroingMessageRpt_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ZeroingMessageRpt_.h"


namespace kartech_linear_actuator_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ZeroingMessageRpt_TypeSupportInterface;

            typedef ZeroingMessageRpt_TypeSupportInterface * ZeroingMessageRpt_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ZeroingMessageRpt_TypeSupportInterface> ZeroingMessageRpt_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ZeroingMessageRpt_TypeSupportInterface> ZeroingMessageRpt_TypeSupportInterface_out;


            class ZeroingMessageRpt_DataWriter;

            typedef ZeroingMessageRpt_DataWriter * ZeroingMessageRpt_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ZeroingMessageRpt_DataWriter> ZeroingMessageRpt_DataWriter_var;
            typedef DDS_DCPSInterface_out < ZeroingMessageRpt_DataWriter> ZeroingMessageRpt_DataWriter_out;


            class ZeroingMessageRpt_DataReader;

            typedef ZeroingMessageRpt_DataReader * ZeroingMessageRpt_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ZeroingMessageRpt_DataReader> ZeroingMessageRpt_DataReader_var;
            typedef DDS_DCPSInterface_out < ZeroingMessageRpt_DataReader> ZeroingMessageRpt_DataReader_out;


            class ZeroingMessageRpt_DataReaderView;

            typedef ZeroingMessageRpt_DataReaderView * ZeroingMessageRpt_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ZeroingMessageRpt_DataReaderView> ZeroingMessageRpt_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ZeroingMessageRpt_DataReaderView> ZeroingMessageRpt_DataReaderView_out;

            struct ZeroingMessageRpt_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ZeroingMessageRpt_, struct ZeroingMessageRpt_Seq_uniq_> ZeroingMessageRpt_Seq;
            typedef DDS_DCPSSequence_var < ZeroingMessageRpt_Seq> ZeroingMessageRpt_Seq_var;
            typedef DDS_DCPSSequence_out < ZeroingMessageRpt_Seq> ZeroingMessageRpt_Seq_out;

            class  ZeroingMessageRpt_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ZeroingMessageRpt_TypeSupportInterface_ptr _ptr_type;
                typedef ZeroingMessageRpt_TypeSupportInterface_var _var_type;

                static ZeroingMessageRpt_TypeSupportInterface_ptr _duplicate (ZeroingMessageRpt_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ZeroingMessageRpt_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ZeroingMessageRpt_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ZeroingMessageRpt_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ZeroingMessageRpt_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ZeroingMessageRpt_TypeSupportInterface () {};
                ~ZeroingMessageRpt_TypeSupportInterface () {};
            private:
                ZeroingMessageRpt_TypeSupportInterface (const ZeroingMessageRpt_TypeSupportInterface &);
                ZeroingMessageRpt_TypeSupportInterface & operator = (const ZeroingMessageRpt_TypeSupportInterface &);
            };

            class  ZeroingMessageRpt_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ZeroingMessageRpt_DataWriter_ptr _ptr_type;
                typedef ZeroingMessageRpt_DataWriter_var _var_type;

                static ZeroingMessageRpt_DataWriter_ptr _duplicate (ZeroingMessageRpt_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ZeroingMessageRpt_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ZeroingMessageRpt_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ZeroingMessageRpt_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ZeroingMessageRpt_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ZeroingMessageRpt_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ZeroingMessageRpt_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ZeroingMessageRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ZeroingMessageRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ZeroingMessageRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ZeroingMessageRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ZeroingMessageRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ZeroingMessageRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ZeroingMessageRpt_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ZeroingMessageRpt_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ZeroingMessageRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ZeroingMessageRpt_& instance_data) = 0;

            protected:
                ZeroingMessageRpt_DataWriter () {};
                ~ZeroingMessageRpt_DataWriter () {};
            private:
                ZeroingMessageRpt_DataWriter (const ZeroingMessageRpt_DataWriter &);
                ZeroingMessageRpt_DataWriter & operator = (const ZeroingMessageRpt_DataWriter &);
            };

            class  ZeroingMessageRpt_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ZeroingMessageRpt_DataReader_ptr _ptr_type;
                typedef ZeroingMessageRpt_DataReader_var _var_type;

                static ZeroingMessageRpt_DataReader_ptr _duplicate (ZeroingMessageRpt_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ZeroingMessageRpt_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ZeroingMessageRpt_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ZeroingMessageRpt_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ZeroingMessageRpt_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ZeroingMessageRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ZeroingMessageRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ZeroingMessageRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ZeroingMessageRpt_& instance) = 0;

            protected:
                ZeroingMessageRpt_DataReader () {};
                ~ZeroingMessageRpt_DataReader () {};
            private:
                ZeroingMessageRpt_DataReader (const ZeroingMessageRpt_DataReader &);
                ZeroingMessageRpt_DataReader & operator = (const ZeroingMessageRpt_DataReader &);
            };

            class  ZeroingMessageRpt_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ZeroingMessageRpt_DataReaderView_ptr _ptr_type;
                typedef ZeroingMessageRpt_DataReaderView_var _var_type;

                static ZeroingMessageRpt_DataReaderView_ptr _duplicate (ZeroingMessageRpt_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ZeroingMessageRpt_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ZeroingMessageRpt_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ZeroingMessageRpt_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ZeroingMessageRpt_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ZeroingMessageRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ZeroingMessageRpt_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ZeroingMessageRpt_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ZeroingMessageRpt_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ZeroingMessageRpt_& instance) = 0;

            protected:
                ZeroingMessageRpt_DataReaderView () {};
                ~ZeroingMessageRpt_DataReaderView () {};
            private:
                ZeroingMessageRpt_DataReaderView (const ZeroingMessageRpt_DataReaderView &);
                ZeroingMessageRpt_DataReaderView & operator = (const ZeroingMessageRpt_DataReaderView &);
            };
        }

    }

}

#endif
